﻿from Npp import *
import datetime
import ctypes
import ctypes.wintypes as wintypes
import re

lexer_name = 'JRiver Media Center 2020 v2'

Am_Activated = False

lexer_name = u'User Defined language file - %s' % lexer_name     #reformat lexer_name
try:

    BH__dict

except NameError:
    
    user32 = wintypes.WinDLL('user32')
    WM_USER = 1024
    NPPMSG = WM_USER+1000
    NPPM_GETLANGUAGEDESC = NPPMSG+84
    SC_INDICVALUEBIT = 0x1000000
    SC_INDICFLAG_VALUEFORE = 1
    npp_hwnd = user32.FindWindowW(u'Notepad++', None)

    BH__dict = dict()

    BH__dict['indic_for_box_at_caret'] = 10  # pick a free indicator number

    def indicatorOptionsSet(indicator_number, indicator_style, rgb_color_tup, alpha, outline_alpha, draw_under_text, which_editor=editor):
        which_editor.indicSetStyle(indicator_number, indicator_style)       # e.g. INDICATORSTYLE.ROUNDBOX
        which_editor.indicSetFore(indicator_number, rgb_color_tup)
        which_editor.indicSetAlpha(indicator_number, alpha)                 # integer
        which_editor.indicSetOutlineAlpha(indicator_number, outline_alpha)  # integer
        which_editor.indicSetUnder(indicator_number, draw_under_text)       # boolean

    for editorX in (editor1, editor2):
        #indicatorOptionsSet(BH__dict['indic_for_box_at_caret'], INDICATORSTYLE.STRAIGHTBOX, (238,121,159), 0, 255, True, editorX)  # white box rimmed in "pale violet red 2"
		indicatorOptionsSet(BH__dict['indic_for_box_at_caret'], INDICATORSTYLE.STRAIGHTBOX, (255,255,255), 0, 255, True, editorX)  # white box
    BH__dict['last_modificationType_for_hack'] = None
    
    def Validate__Bracket(str_containing_caret, position):
        #This will return True if the bracket is part of an expression and should be neutered
        PADMAX = 10     #this is the maximum size of our lookaround , for crushing whitespace
        CUR_CHAR = str_containing_caret[position]
        PADL=position
        if position > PADMAX+1: PADL = PADMAX  #reset pad left for max search size
        
        if len(str_containing_caret) - position > PADMAX+1:
            PADR = PADMAX
        else:
            PADR = len(str_containing_caret) - position
        
        LOOKBEHIND = str_containing_caret[position  - PADL:position]  #get our lookbehind string
        
        #Check for a literal quote / that escapes the symbol
        if len(LOOKBEHIND)>0:
            if LOOKBEHIND[-1] == '/': 
                return True     #That's it. The <> was quoted so no need to look further
            
        LOOKAHEAD = str_containing_caret[position+1: position +1 + PADR]  #get lookahead string
        LOOKBEHIND = re.sub('\s*', '', LOOKBEHIND)  #crush the whitespace
        LOOKAHEAD = re.sub('\s*', '', LOOKAHEAD)

        L1 = ''
        R1 = ''
        if len(LOOKBEHIND)>0: L1 = LOOKBEHIND[-1]
        if len(LOOKAHEAD)>0: R1 = LOOKAHEAD[0]
        TESTSTR=L1 + CUR_CHAR + R1   #we have a 3-char string with our bracket in the middle and no whitespace

        #Now for a couple of regex to detect the Compare() and Math() functions
        COMPARERESULT = re.search('[,][><][,=]',TESTSTR)
        MATHRESULT = re.search('[\d\]][><][\[\d]',TESTSTR)
        if MATHRESULT or COMPARERESULT: return True
        else: return False
        
    def BH__containing_box_indices_into_string(str_containing_caret, caret_index_into_str):

        class Stack:
            def __init__(self): self.clear()
            def isEmpty(self): return self.size() == 0
            def push(self, item): self.items.append(item)
            def pop(self): return None if self.size() == 0 else self.items.pop()
            def peek(self): return None if self.size() == 0 else self.items[self.size() - 1]
            def size(self): return len(self.items)
            def clear(self): self.items = []

        retval = (None, None)  # default to no valid box

        get_opening_char_via_closing_char_dict = {
           	')' : '(',
            ']' : '[',
           # '}' : '{',		#{} must be ignored because MC uses them as unmatched operators in Math(), which would cause unclosed clauses
            '>' : '<',		#[] have the same problem, and are overloaded as both mathematical operators and tag delimiters. BAD!
           # '"' : '"',		#identical opening and closing delimiters cause problems, so ignore.
            }
        get_closing_char_via_opening_char_dict = dict((v, k) for (k, v) in get_opening_char_via_closing_char_dict.items())

        closing_chars = get_opening_char_via_closing_char_dict.keys()
        opening_chars = get_opening_char_via_closing_char_dict.values()

        box_ending_index = -1
        box_starting_index = -1

        stack = Stack()
 
        LAST_TRIG = ''
        
        #Begin forwards scan
        for j in range(caret_index_into_str, len(str_containing_caret)):
            c = str_containing_caret[j]
            ################## ESCAPE HANDLING FORWARDS##################
            if LAST_TRIG == '/':     # we're going to skip this character whatever it is
                NEUTER = False
                LAST_TRIG = ''
                continue
            NEUTER=False
            if c in '<>': NEUTER = Validate__Bracket(str_containing_caret, j)
            
            if c == '/': 
                LAST_TRIG = c
                continue
            else: LAST_TRIG = ''    #set it or forget it
           
            if NEUTER: continue     #nothing more to do at this point
            if c in closing_chars:
                if stack.isEmpty():
                    box_ending_index = j
                    break
                else:
                    if stack.peek() ==  get_opening_char_via_closing_char_dict[c]:
                        stack.pop()
                    else:
                        break  # unbalanced
            elif c in opening_chars:
                stack.push(c)
                
                
        #Begin backwards scan
        if box_ending_index != -1:
            stack.clear()
            box_starting_index = -1
            for j in range(caret_index_into_str - 1, -1, -1):
                c = str_containing_caret[j]
                NEUTER=False
                        
                if c in '<>': NEUTER = Validate__Bracket(str_containing_caret, j)
                #also look backwards if we can
                if j > 0:   #this will ignore things other chars if escaped
                    if str_containing_caret[j-1] == '/': NEUTER = True

                if NEUTER: continue
                if c in opening_chars:
                    if stack.isEmpty():
                        box_starting_index = j
                        break
                    else:
                        if stack.peek() ==  get_closing_char_via_opening_char_dict[c]:
                            stack.pop()
                        else:
                            break  # unbalanced
                elif c in closing_chars:
                    stack.push(c)

        if box_ending_index != -1:
            if box_starting_index != -1:
                if str_containing_caret[box_ending_index] == get_closing_char_via_opening_char_dict[str_containing_caret[box_starting_index]]:
                    retval = (box_starting_index, box_ending_index + 1)

        return retval

#=========================================================================================================================================================
    def on_bufferactivated(args):
        '''
            Callback which gets called every time one switches a document.
            Triggers the check if the document is of interest.
        '''
        check_lexer()
 
    def on_langchanged(args):
        '''
            Callback gets called every time one uses the Language menu to set a lexer
            Triggers the check if the document is of interest
        '''
        check_lexer()

    def check_lexer():
        '''
            Checks if the current document is of interest
            and sets the flag accordingly
        '''
        global Am_Activated
        
        language = notepad.getLangType()
        length = user32.SendMessageW(npp_hwnd, NPPM_GETLANGUAGEDESC, language, None)
        buffer = ctypes.create_unicode_buffer(u' ' * length)
        user32.SendMessageW(npp_hwnd, NPPM_GETLANGUAGEDESC, language, ctypes.byref(buffer))
        Am_Activated = True if buffer.value == lexer_name or 'JRiver' in buffer.value else False
        if Am_Activated == False: BH__CLEARUI()
        

    def BH__callback_sci_MODIFIED(args):
        global BH__dict
        if not Am_Activated: return

        BH__dict['last_modificationType_for_hack'] = args['modificationType']

    def BH__fileIsCloned(file_name_to_test):
        retval = False
        clone_detect_dict = {}
        file_tup_list = notepad.getFiles()
        for tup in file_tup_list:
            (filename, _, _, _) = tup
            if filename not in clone_detect_dict:
                clone_detect_dict[filename] = 0
            else:
                clone_detect_dict[filename] += 1
                if filename == file_name_to_test: break
        if file_name_to_test in clone_detect_dict:
            if clone_detect_dict[file_name_to_test] >= 1: retval = True
        return retval

    def BH__fileIsClonedAndIsActiveInBothViews(file_name_to_test):
        retval = False
        if editor1 and editor2:
            # both views are in use
            if BH__fileIsCloned(file_name_to_test):
                curr_doc_index_main_view = notepad.getCurrentDocIndex(0)
                curr_doc_index_2nd_view = notepad.getCurrentDocIndex(1)
                main_view_active_doc_bool = False
                secondary_view_active_doc_bool = False
                file_tup_list = notepad.getFiles()
                for tup in file_tup_list:
                    (filename, _, index_in_view, view_number) = tup
                    if filename == file_name_to_test:
                        if view_number == 0:
                            if index_in_view == curr_doc_index_main_view:
                                main_view_active_doc_bool = True
                        elif view_number == 1:
                            if index_in_view == curr_doc_index_2nd_view:
                                secondary_view_active_doc_bool = True
                        if main_view_active_doc_bool and secondary_view_active_doc_bool:
                            retval = True
                            break
        return retval

    def BH__getViewableEditorAndRangeTupleListList(work_across_both_views):
        retval = []
        # retval looks like these examples:
        #  [ ( editor, [ (0, 1000), (2020, 3000) ] ) ]
        #  [ ( editor1, [ (0, 1000), (2020, 3000) ] ), ( editor2, [ (4000, 5000), (6020, 7000) ] ) ]
        def consolidate_range_tuple_list(range_tup_list):
            sorted_range_tup_list = sorted(range_tup_list)  # sort criteria is first element of tuple in list
            saved_2element_list = list(sorted_range_tup_list[0])
            for (start, end) in sorted_range_tup_list:
                if start <= saved_2element_list[1]:
                    saved_2element_list[1] = max(saved_2element_list[1], end)
                else:
                    yield tuple(saved_2element_list)
                    saved_2element_list[0] = start
                    saved_2element_list[1] = end
            yield tuple(saved_2element_list)
        def get_onscreen_pos_tup_list(which_editor):  # which_editor is editor1 or editor2 (or maybe even just plain editor)
            # loosely based upon the N++ source for SmartHighlighter::highlightViewWithWord()
            retval_tup_list = list()
            temp_tup_list = []
            MAXLINEHIGHLIGHT = 400
            firstLine = which_editor.getFirstVisibleLine()
            currentLine = firstLine
            nbLineOnScreen = which_editor.linesOnScreen()
            nrLines = min(nbLineOnScreen, MAXLINEHIGHLIGHT) + 1
            lastLine = firstLine + nrLines
            prevDocLineChecked = -1
            break_out = False
            while currentLine < lastLine:
                docLine = which_editor.docLineFromVisible(currentLine)
                if docLine != prevDocLineChecked:
                    prevDocLineChecked = docLine
                    startPos = which_editor.positionFromLine(docLine)
                    endPos = which_editor.positionFromLine(docLine + 1)
                    if endPos == -1:
                        endPos = which_editor.getTextLength() - 1
                        break_out = True
                    if endPos > startPos: temp_tup_list.append((startPos, endPos))
                    if break_out: break
                currentLine += 1
            if len(temp_tup_list) > 0:
                retval_tup_list = list(consolidate_range_tuple_list(temp_tup_list))
            return retval_tup_list
        both_views_open = True if editor1 and editor2 else False
        curr_file_active_in_both_views = BH__fileIsClonedAndIsActiveInBothViews(notepad.getCurrentFilename()) if both_views_open else False
        if both_views_open:
            ed1_range_tup_list = get_onscreen_pos_tup_list(editor1)
            ed2_range_tup_list = get_onscreen_pos_tup_list(editor2)
        if curr_file_active_in_both_views:
            range_tup_list = list(consolidate_range_tuple_list(ed1_range_tup_list + ed2_range_tup_list))
            retval.append((editor, range_tup_list))
        elif both_views_open and work_across_both_views:
            retval.append((editor1, ed1_range_tup_list))
            retval.append((editor2, ed2_range_tup_list))
        else:
            range_tup_list = get_onscreen_pos_tup_list(editor)
            retval.append((editor, range_tup_list))
        return retval

#=========================================================================================================================================================
    def BH__CLEARUI():
        global BH__dict
        # hack, see https://notepad-plus-plus.org/community/topic/12360/vi-simulator-how-to-highlight-a-word/27, look for "16400" in code:

        for (editorX, pos_range_tuple_list) in BH__getViewableEditorAndRangeTupleListList(True):

            # clear out any existing highlighting in areas the user can currently see
            for (start_pos, end_pos) in pos_range_tuple_list:
                editorX.setIndicatorCurrent(BH__dict['indic_for_box_at_caret'])
                editorX.indicatorClearRange(start_pos, end_pos - start_pos)

    def BH__callback_sci_UPDATEUI(args):
        global BH__dict
        if not Am_Activated: return
 
        # hack, see https://notepad-plus-plus.org/community/topic/12360/vi-simulator-how-to-highlight-a-word/27, look for "16400" in code:
        if args['updated'] == UPDATE.CONTENT and BH__dict['last_modificationType_for_hack'] == (MODIFICATIONFLAGS.CHANGEINDICATOR | MODIFICATIONFLAGS.USER): return

        for (editorX, pos_range_tuple_list) in BH__getViewableEditorAndRangeTupleListList(True):

            # clear out any existing highlighting in areas the user can currently see
            for (start_pos, end_pos) in pos_range_tuple_list:
                editorX.setIndicatorCurrent(BH__dict['indic_for_box_at_caret'])
                editorX.indicatorClearRange(start_pos, end_pos - start_pos)

            for (start_pos, end_pos) in pos_range_tuple_list:

                if start_pos <= editorX.getCurrentPos() <= end_pos:

                    (box_start_offset, box_end_offset) = BH__containing_box_indices_into_string(
                        editorX.getTextRange(start_pos, end_pos),
                        editorX.getCurrentPos() - start_pos
                        )

                    if box_start_offset != None:
                        size_of_box_in_chars = box_end_offset - box_start_offset
                        if size_of_box_in_chars <= 2:
                            pass  # rather pointless to box in if the opening and closing delims are right next to each other
                        else:
                            editorX.setIndicatorCurrent(BH__dict['indic_for_box_at_caret'])
                            editorX.indicatorFillRange(start_pos + box_start_offset, size_of_box_in_chars)

    editor.callbackSync(BH__callback_sci_UPDATEUI, [SCINTILLANOTIFICATION.UPDATEUI])  # install callback
    editor.callbackSync(BH__callback_sci_MODIFIED, [SCINTILLANOTIFICATION.MODIFIED])  # may not need to be "Sync", but for now we'll make it that way
    notepad.callback(on_langchanged, [NOTIFICATION.LANGCHANGED])
    notepad.callback(on_bufferactivated, [NOTIFICATION.BUFFERACTIVATED])
    check_lexer()



else:

    editor.setSelectionMode(editor.getSelectionMode())  # force manual UPDATEUI to happen